with GNATCOM.Dispinterface;

package MSHTML.IHTMLSelectElement_Interface is

   type IHTMLSelectElement_Type is
     new GNATCOM.Dispinterface.Dispinterface_Type with null record;

   procedure Initialize (This : in out IHTMLSelectElement_Type);

   function Pointer (This : IHTMLSelectElement_Type)
     return Pointer_To_IHTMLSelectElement;

   procedure Attach (This    : in out IHTMLSelectElement_Type;
                     Pointer : in     Pointer_To_IHTMLSelectElement);

   procedure Put_size
     (This : IHTMLSelectElement_Type;
      p    : Interfaces.C.long);

   function Get_size
     (This : IHTMLSelectElement_Type)
     return Interfaces.C.long;

   procedure Put_multiple
     (This : IHTMLSelectElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL);

   function Get_multiple
     (This : IHTMLSelectElement_Type)
     return GNATCOM.Types.VARIANT_BOOL;

   procedure Put_name
     (This : IHTMLSelectElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True);

   function Get_name
     (This : IHTMLSelectElement_Type)
     return GNATCOM.Types.BSTR;

   function Get_options
     (This : IHTMLSelectElement_Type)
     return GNATCOM.Types.Pointer_To_IDispatch;

   procedure Put_onchange
     (This : IHTMLSelectElement_Type;
      p    : GNATCOM.Types.VARIANT;
      Free : Boolean := True);

   function Get_onchange
     (This : IHTMLSelectElement_Type)
     return GNATCOM.Types.VARIANT;

   procedure Put_selectedIndex
     (This : IHTMLSelectElement_Type;
      p    : Interfaces.C.long);

   function Get_selectedIndex
     (This : IHTMLSelectElement_Type)
     return Interfaces.C.long;

   function Get_type
     (This : IHTMLSelectElement_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_value
     (This : IHTMLSelectElement_Type;
      p    : GNATCOM.Types.BSTR;
      Free : Boolean := True);

   function Get_value
     (This : IHTMLSelectElement_Type)
     return GNATCOM.Types.BSTR;

   procedure Put_disabled
     (This : IHTMLSelectElement_Type;
      p    : GNATCOM.Types.VARIANT_BOOL);

   function Get_disabled
     (This : IHTMLSelectElement_Type)
     return GNATCOM.Types.VARIANT_BOOL;

   function Get_form
     (This : IHTMLSelectElement_Type)
     return Pointer_To_IHTMLFormElement;

   procedure add
     (This    : IHTMLSelectElement_Type;
      element : Pointer_To_IHTMLElement;
      before  : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free    : Boolean := True);

   procedure remove
     (This  : IHTMLSelectElement_Type;
      index : Interfaces.C.long);

   procedure Put_length
     (This : IHTMLSelectElement_Type;
      p    : Interfaces.C.long);

   function Get_length
     (This : IHTMLSelectElement_Type)
     return Interfaces.C.long;

   function Getu_newEnum
     (This : IHTMLSelectElement_Type)
     return GNATCOM.Types.Pointer_To_IUnknown;

   function item
     (This  : IHTMLSelectElement_Type;
      name  : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      index : GNATCOM.Types.VARIANT  := GNATCOM.Types.VARIANT_MISSING;
      Free  : Boolean := True)
     return GNATCOM.Types.Pointer_To_IDispatch;

   function tags
     (This    : IHTMLSelectElement_Type;
      tagName : GNATCOM.Types.VARIANT;
      Free    : Boolean := True)
     return GNATCOM.Types.Pointer_To_IDispatch;

end MSHTML.IHTMLSelectElement_Interface;

